package ru.dbotthepony.mc.otm.capability;

import net.minecraftforge.common.capabilities.Capability;
import net.minecraftforge.common.capabilities.CapabilityInject;
import net.minecraftforge.common.capabilities.CapabilityManager;
import net.minecraftforge.energy.IEnergyStorage;

import java.math.BigDecimal;
import java.math.MathContext;
import java.math.RoundingMode;

public class MatteryCapability {
	@CapabilityInject(IMatteryEnergyStorage.class)
	public static Capability<IMatteryEnergyStorage> ENERGY = null;

	@CapabilityInject(IAndroidCapability.class)
	public static Capability<IAndroidCapability> ANDROID = null;

	public static void register() {
		CapabilityManager.INSTANCE.register(IAndroidCapability.class);
		CapabilityManager.INSTANCE.register(IMatteryEnergyStorage.class);
	}

	public static final MathContext ROUND_RULES = new MathContext(16, RoundingMode.HALF_UP);

	public static final BigDecimal INT_MAX_VALUE = new BigDecimal(Integer.MAX_VALUE);
	public static final BigDecimal INT_MIN_VALUE = new BigDecimal(Integer.MIN_VALUE);

	public static final BigDecimal LONG_MAX_VALUE = new BigDecimal(Long.MAX_VALUE);
	public static final BigDecimal LONG_MIN_VALUE = new BigDecimal(Long.MIN_VALUE);

	public static BigDecimal drainFE(IEnergyStorage capability, BigDecimal howMuch, boolean simulate) {
		if (howMuch.compareTo(BigDecimal.ONE) < 0)
			return BigDecimal.ZERO;

		return new BigDecimal(capability.extractEnergy(howMuch.compareTo(INT_MAX_VALUE) > 0 ? Integer.MAX_VALUE : howMuch.intValue(), simulate));
	}

	public static BigDecimal floodFE(IEnergyStorage capability, BigDecimal howMuch, boolean simulate) {
		if (howMuch.compareTo(BigDecimal.ONE) < 0)
			return BigDecimal.ZERO;

		return new BigDecimal(capability.receiveEnergy(howMuch.compareTo(INT_MAX_VALUE) > 0 ? Integer.MAX_VALUE : howMuch.intValue(), simulate));
	}
}
