package ru.dbotthepony.mc.otm.network;

import net.minecraft.resources.ResourceLocation;
import net.minecraftforge.fmllegacy.network.NetworkDirection;
import net.minecraftforge.fmllegacy.network.NetworkRegistry;
import net.minecraftforge.fmllegacy.network.simple.SimpleChannel;
import ru.dbotthepony.mc.otm.OverdriveThatMatters;

import java.util.Optional;

public class MatteryNetwork {
	private static final String PROTOCOL_VERSION = "1";

	private static int next_network_id = 0;

	public static final SimpleChannel ANDROID_PLAYER = NetworkRegistry.newSimpleChannel(
		new ResourceLocation(OverdriveThatMatters.MOD_ID, "android_player"),
		() -> PROTOCOL_VERSION,
		PROTOCOL_VERSION::equals,
		PROTOCOL_VERSION::equals
	);

	public static void register() {
		ANDROID_PLAYER.registerMessage(
			next_network_id++,
			AndroidCapabilityChangePacket.class,
			AndroidCapabilityChangePacket::encodeNetwork,
			AndroidCapabilityChangePacket::decodeNetwork,
			AndroidCapabilityChangePacket::handleMessage,
			Optional.of(NetworkDirection.PLAY_TO_CLIENT)
		);
	}
}
